Ruby: pm_local_variable_or_write_node Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
pm_local_variable_or_write_node Struct Reference

LocalVariableOrWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_location_t | name_loc
| LocalVariableOrWriteNode::name_loc.
pm_location_t | operator_loc
| LocalVariableOrWriteNode::operator_loc.
struct pm_node * | value
| LocalVariableOrWriteNode::value.
pm_constant_id_t | name
| LocalVariableOrWriteNode::name.
uint32_t | depth
| LocalVariableOrWriteNode::depth.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

LocalVariableOrWriteNode.

Represents the use of the `||=` operator for assignment to a local variable.

    target ||= value
    ^^^^^^^^^^^^^^^^

Type: PM_LOCAL_VARIABLE_OR_WRITE_NODE

Definition at line 5670 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_local_variable_or_write_node::base

The embedded base node.

Definition at line 5672 of file ast.h.

Referenced by pm_dump_json().

## ◆ depth

uint32_t pm_local_variable_or_write_node::depth

LocalVariableOrWriteNode::depth.

Definition at line 5698 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_local_variable_or_write_node::name

LocalVariableOrWriteNode::name.

Definition at line 5693 of file ast.h.

Referenced by pm_dump_json().

## ◆ name_loc

pm_location_t pm_local_variable_or_write_node::name_loc

LocalVariableOrWriteNode::name_loc.

Definition at line 5678 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_local_variable_or_write_node::operator_loc

LocalVariableOrWriteNode::operator_loc.

Definition at line 5683 of file ast.h.

Referenced by pm_dump_json().

## ◆ value

struct pm_node* pm_local_variable_or_write_node::value

LocalVariableOrWriteNode::value.

Definition at line 5688 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h